 
      SUBROUTINE INITIAL
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c MultiWell: a code for chemical kinetics calculations.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c
c	Initialize bookkeeping arrays between trials
c
      IMPLICIT NONE
      INCLUDE 'declare1.inc'
      INCLUDE 'declare2.inc'
      INTEGER i , j , k , n
      SAVE 
 
      DO 200 i = 1 , NWells
 
         DO 50 j = 1 , Ntime
            EMol(i,j) = 0.0D+00 ! average vibrational energy
            Num(i,j) = 0        ! number of samples for molecular properties
            Nuni(i,j) = 0       ! number of samples for reaction rates
            DO 20 n = 1 , Nchan(i)
               kuni(i,n,j) = 0.0D+00
                                ! average unimolecular rates
 20         CONTINUE
 50      CONTINUE
 
         DO 100 j = 1 , Ndist
            DO 60 k = 1 , Mtime
               EDIST(i,j,k) = 0 ! vibrational distribution
 60         CONTINUE
 100     CONTINUE
 
         DO 110 j = 1 , Mtime
            Mum(i,j) = 0
 110     CONTINUE

 200  CONTINUE
 
      DO 300 i = 1 , Isize
         Nstart(i) = 0          ! distribution of selected starting energies
 300  CONTINUE
 
 
      IF ( NProds.GT.0 ) THEN
         DO 350 i = NWells + 1 , NWells + NProds
            DO 320 j = 1 , Ntime
               Num(i,j) = 0     ! number of samples for molecular properties
 320        CONTINUE
 350     CONTINUE
      ENDIF
 
      RETURN
      END
